unit MakeLossy;

interface
uses
  wavIO;

procedure makeLossySampleBlock(var sampleBlock: allChannelsSampleBlock; samplesCount: integer);
                                                            // Transforms sampleBlock
                                                            // into a lossy version by keeping only the 11 MSBs
                                                            // (setting the other ones to zero).

implementation

function lossySample(sample: LongInt): LongInt;
 begin
  lossySample := sample AND $FFE00000  // all bits except for the 11 MSB set to 0
 end;

procedure makeLossySampleBlock(var sampleBlock: allChannelsSampleBlock; samplesCount: integer);
var
 i, iChannel, lastChannelIndex: integer;
 begin
    lastChannelIndex := channelCount() - 1;
    for i:= 0 to samplesCount -1 do
        for iChannel:= 0 to lastChannelIndex do
            sampleBlock[iChannel, i] := lossySample(sampleBlock[iChannel, i]);
 end;

end.
